
ODBCConnect proc hDlg:DWORD
	local ResultFile:WIN32_FIND_DATA
	;la fonction SQLDriverConnect ne prend pas en compte le nom de fichier
	invoke FindFirstFile,addr NomComplet,addr ResultFile
	.if eax == INVALID_HANDLE_VALUE
		invoke MessageBox,hDlg, addr ErFich ,addr AppName,MB_OK+MB_ICONERROR
		ret
	.else
	 invoke  CloseHandle,eax		
	.endif
	invoke SQLAllocHandle, SQL_HANDLE_ENV, SQL_NULL_HANDLE, addr hEnv
	.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
		invoke SQLSetEnvAttr, hEnv,SQL_ATTR_ODBC_VERSION, SQL_OV_ODBC3,0
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			invoke SQLAllocHandle, SQL_HANDLE_DBC, hEnv, addr hConn
			.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
				invoke lstrcpy,addr ConnectString,addr strConnect
				invoke lstrcat,addr ConnectString, addr NomComplet
				invoke SQLDriverConnect, hConn, hDlg, addr ConnectString, sizeof ConnectString, addr Conn, sizeof Conn,addr LongChaine, SQL_DRIVER_COMPLETE
				.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
					invoke SwitchMenuState,TRUE
					invoke MessageBox,hDlg, addr Conn,addr ConnectCaption,MB_OK+MB_ICONINFORMATION
				.else
					invoke SQLGetDiagRec,SQL_HANDLE_DBC,hConn,1,addr SQLState,addr NativeError \
						,addr ODBCerreurMesgTxt,sizeof ODBCerreurMesgTxt,addr NbtexteRetourne
					invoke ShowWindow, hList, SW_HIDE
					invoke MessageBox,hDlg,addr ODBCerreurMesgTxt, addr AppName, MB_OK

					invoke SQLFreeHandle, SQL_HANDLE_DBC, hConn
					invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
					invoke MessageBox, hDlg, addr ConnFail, addr AppName, MB_OK+MB_ICONERROR
				.endif
			.else
				invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
				invoke MessageBox, hDlg, addr AllocConnFail, addr AppName, MB_OK+MB_ICONERROR
			.endif
		.else
			invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
			invoke MessageBox, hDlg, addr SetAttrFail, addr AppName, MB_OK+MB_ICONERROR
		.endif
	.else
		invoke MessageBox, hDlg, addr AllocEnvFail, addr AppName, MB_OK+MB_ICONERROR	
	.endif
	ret
ODBCConnect endp

ODBCDisconnect proc hDlg:DWORD
	invoke SQLDisconnect, hConn
	invoke SQLFreeHandle, SQL_HANDLE_DBC, hConn
	invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
	invoke SwitchMenuState, FALSE
	invoke ShowWindow,hList, SW_HIDE
	;invoke MessageBox,hDlg,addr Disconnect, addr AppName,MB_OK+MB_ICONINFORMATION
	ret
ODBCDisconnect endp

InsertColumn proc
	LOCAL lvc:LV_COLUMN
	mov lvc.imask,LVCF_TEXT+LVCF_WIDTH
	mov lvc.pszText,offset Heading1
	mov lvc.lx,150
	invoke SendMessage,hList, LVM_INSERTCOLUMN,0,addr lvc
	mov lvc.pszText,offset Heading2
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 1 ,addr lvc	
	mov lvc.pszText,offset Heading3
	invoke SendMessage,hList, LVM_INSERTCOLUMN, 3 ,addr lvc	
	ret		
InsertColumn endp

FillData proc
	LOCAL lvi:LV_ITEM
	LOCAL row:DWORD

	invoke SQLBindCol, hStmt,1,SQL_C_CHAR, addr TheName, sizeof TheName,addr NameLength
	invoke SQLBindCol, hStmt,2,SQL_C_CHAR, addr TheSurname, sizeof TheSurname,addr SurnameLength
	invoke SQLBindCol, hStmt,3,SQL_C_CHAR, addr TelNo, sizeof TelNo,addr TelNoLength
	mov row,0
	.while TRUE
		mov byte ptr ds:[TheName],0
		mov byte ptr ds:[TheSurname],0
		mov byte ptr ds:[TelNo],0
		invoke SQLFetch, hStmt
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			mov lvi.imask,LVIF_TEXT+LVIF_PARAM
			push row
			pop lvi.iItem	
			mov lvi.iSubItem,0
			mov lvi.pszText, offset TheName
			push row
			pop lvi.lParam
			invoke SendMessage,hList, LVM_INSERTITEM,0, addr lvi
			mov lvi.imask,LVIF_TEXT
			inc lvi.iSubItem
			mov lvi.pszText,offset TheSurname
			invoke SendMessage,hList,LVM_SETITEM, 0,addr lvi
			inc lvi.iSubItem
			mov lvi.pszText,offset TelNo
			invoke SendMessage,hList,LVM_SETITEM, 0,addr lvi
			inc row
		.else
			.break
		.endif
	.endw
	ret
FillData endp

RunQuery proc hDlg:DWORD
	invoke ShowWindow, hList, SW_SHOW
	invoke SendMessage, hList, LVM_DELETEALLITEMS,0,0
	invoke SQLAllocHandle, SQL_HANDLE_STMT, hConn, addr hStmt
	and eax,0FFFFh
	.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
		invoke MessageBox,hDlg,addr SQLStatement,addr AppName,MB_OK
		invoke SQLExecDirect, hStmt, addr SQLStatement, sizeof SQLStatement
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			invoke FillData
		.else
			push eax
			invoke SQLGetDiagRec,SQL_HANDLE_STMT,hStmt,1,addr SQLState,addr NativeError \
				,addr ODBCerreurMesgTxt,sizeof ODBCerreurMesgTxt,addr NbtexteRetourne
			invoke ShowWindow, hList, SW_HIDE
			invoke MessageBox,hDlg,addr ExecuteFail, addr AppName, +MB_ICONERROR
			pop edx
			;invoke dwtoa,edx,addr ZoneMessagesErreurs
			invoke dw2hex,edx,addr ZoneMessagesErreurs
			invoke MessageBox,hDlg,addr ODBCerreurMesgTxt, addr AppName, MB_OK

		.endif
		invoke SQLCloseCursor, hStmt
		invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
	.else
		invoke ShowWindow, hList, SW_HIDE
		invoke MessageBox,hDlg,addr AllocStmtFail, addr AppName, MB_OK+MB_ICONERROR
	.endif
	ret
RunQuery endp
QueryProc proc hDlg:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD	
	.if uMsg==WM_CLOSE
		invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
		invoke EndDialog, hDlg,0
	.elseif uMsg==WM_INITDIALOG
		invoke ShowWindow, hList, SW_SHOW
		invoke SQLAllocHandle, SQL_HANDLE_STMT, hConn, addr hStmt
		.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
			invoke lstrcpy, addr Conn, addr SQLStatement
			invoke lstrcat, addr Conn, addr WhereStatement
			invoke SQLBindParameter,hStmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR,25,0, addr SearchName,25,addr LongChaine
			invoke SQLPrepare, hStmt, addr Conn, sizeof Conn
			InsTxt   TITRE000,"Conn"
			invoke MessageBox,hDlg,ADDR Conn,ADDR TITRE000,MB_OK

		.else
			invoke ShowWindow, hList, SW_HIDE
			invoke MessageBox,hDlg,addr AllocStmtFail, addr AppName, MB_OK+MB_ICONERROR
			invoke EndDialog, hDlg,0
		.endif	
	.elseif uMsg==WM_COMMAND
		mov eax, wParam
		shr eax,16
		.if ax==BN_CLICKED
			mov eax,wParam
			.if ax==IDC_OK
				invoke GetDlgItemText, hDlg, IDC_NAME, addr SearchName, 25
				.if ax==0
					invoke MessageBox, hDlg,addr NoData, addr AppName, MB_OK+MB_ICONERROR
					invoke GetDlgItem, hDlg, IDC_NAME
					invoke SetFocus, eax
				.else
					invoke lstrlen,addr SearchName
					mov LongChaine,eax
			InsTxt   TITRE001,"searchname"
			invoke MessageBox,hDlg,ADDR SearchName,ADDR TITRE001,MB_OK

					invoke SendMessage, hList, LVM_DELETEALLITEMS,0,0
					invoke SQLExecute, hStmt
					.if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
						invoke FillData
					.else
						push eax
						invoke SQLGetDiagRec,SQL_HANDLE_STMT,hStmt,1,addr SQLState,addr NativeError \
							,addr ODBCerreurMesgTxt,sizeof ODBCerreurMesgTxt,addr NbtexteRetourne
						invoke ShowWindow, hList, SW_HIDE
						invoke MessageBox,hDlg,addr ExecuteFail, addr AppName, +MB_ICONERROR
						pop edx
						;invoke dwtoa,edx,addr ZoneMessagesErreurs
						invoke dw2hex,edx,addr ZoneMessagesErreurs
						invoke MessageBox,hDlg,addr ODBCerreurMesgTxt, addr AppName, MB_OK

					.endif
					invoke SQLCloseCursor, hStmt
				.endif
			.else
				invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
				invoke EndDialog, hDlg,0
			.endif
		.endif
	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	ret
QueryProc endp
